#include "hmg.ch"
#include "hmg_BoxLetterShow.ch"
#include "hfcl_gridprint.ch"

#command COMPRESS [ FILES ] <afiles> ;
		TO <zipfile>  ;
		BLOCK <block> ;
		[ RESULT [ TO ] <lSuccess> ] ;
		[ LEVEL <level> ] ;
		[ <ovr: OVERWRITE> ] ;
		[ PASSWORD <password> ] ;
		[ <srp: STOREPATH> ] ;
		[ FILEPROGRESS <fileblock> ] ;
	=> ;
	[ <lSuccess> := ] hb_ZipFile( <zipfile> , <afiles> , <level> , <block> , <.ovr.> , <password> , <.srp.> , , <fileblock> )

#command UNCOMPRESS [ FILE ] <zipfile> ;
		[ EXTRACTPATH <extractpath> ] ;
		[ RESULT [ TO ] <lSuccess> ] ;
		[ BLOCK <block> ] ;
		[ <createdir: CREATEDIR> ] ;
		[ PASSWORD <password> ] ;
		[ <dummy1: FILEMASK, FILEARRAY> <mask> ] ;
		[ FILEPROGRESS <fileblock> ] ;
	=> ;
	[ <lSuccess> := ] hb_UnZipFile( <zipfile> , <block> , <.createdir.> , <password> , <extractpath> , <mask> , <fileblock> )

*------------------------------------------------------------------------------*
 Function Main()
*------------------------------------------------------------------------------*
 
*-----------------------------------------------------------*
*  Mustafa Lpez  mustalopez@gmail.com
* http://www.hmgforum.com/viewtopic.php?f=9&t=4795&start=10
*   Revisin con Suma de Horas  04-11-2019
*-----------------------------------------------------------*

  REQUEST HB_CODEPAGE_ESWIN     
  HB_SETCODEPAGE("ESWIN")    
 
  REQUEST HB_LANG_ES   
  HB_LANGSELECT("ES")  
*----------------------------------*
  SET CENTURY ON
  SET DATE FRENCH
  SET ESCAPE ON
  SET NAVIGATION EXTENDED
  SET LANGUAGE TO SPANISH 
  SET CODEPAGE TO SPANISH
  SET DELETED ON
  SET DATE FORMAT TO 'dd/mm/yyyy'
  SET BROWSESYNC ON
  SET INTERACTIVECLOSE ON
  SET TOOLTIPSTYLE BALLOON
*-------------------------------------*
  PUBLIC dbo    := nil
*-------------------------------------*
  PUBLIC PriNc  := HB_Curdrive() +":\"+Rtrim(Curdir() ) + "\"       && <- Directorio Principal
  PUBLIC DirZY  := HB_Curdrive() +":\"+Rtrim(Curdir() ) + "\"+"Backup_Files\" 
*---------------------------------------------------------------------------------------------* 
 #pragma TEXTHIDDEN(1) 
   PUBLIC  cKey     := "Q65h3l8j41B"  // <- Very important not to change Password or Delete !!!                  
 #pragma TEXTHIDDEN(0) 
*---------------------------------------------------------------------------------------------*
*-------------------------------------------------------------------*
  PUBLIC nCtEfeito    := 0
  PUBLIC nCt          := 1
  PUBLIC cDescEfeito  := ""
  PUBLIC ficher , cFileD
*-------------------------------------------------------------------*
  PUBLIC SixNox 
  PUBLIC aChecbo 
  PUBLIC aGrid       := {}
  PUBLIC aTable      := {}
  PUBLIC cNewRecNo
  PUBLIC mRecPtr     := 0
  PUBLIC mRecCount   := 0
  PUBLIC oDB         := Nil 
  PUBLIC nOrder      := 0
*--------------------------------------------------------------------*
  PUBLIC una := 0
  una := 0
  SAVE TO zControl.mem ALL LIKE una*
*--------------------------------------------------------------------*
  RescueZip()    // Prepara Databases Operativas 
*--------------------------------------------------------------------*
  PUBLIC aNivName := ""
  PUBLIC bNivName := ""
  PUBLIC cNivName := ""  
  PUBLIC dNivName := ""
  PUBLIC eNivName := ""
  PUBLIC fNivName := ""
  PUBLIC gNivName := ""

  PUBLIC hNivName := ""
  PUBLIC iNivName := ""
  PUBLIC jNivName := ""  
  PUBLIC kNivName := ""
  PUBLIC lNivName := ""
  PUBLIC mNivName := ""
*---------------------------------------------------------------------*
  FileDelete ('controlM.mem')
  nOrder := 1
  SAVE TO controlM.mem ALL LIKE nOrder*
*---------------------------------------------------------------------*

  DEFINE WINDOW  Win_1            ;
      AT 0,0                      ;
      WIDTH  1125                 ;            
      HEIGHT 725                  ; 
      TITLE  "Base SQLite Photo"  ;
      ICON 'Logo'                 ; 
      BACKCOLOR { 031,154,108 }   ;
      MAIN NOSYSMENU CURSOR ""    ; 
      ON INIT  password_control()   

      ON KEY ESCAPE ACTION FinalProgram() 

      DEFINE TIMER Timer_1abQ ;
              INTERVAL 100 ;
              ACTION { || thisWindow.Row := 005, thisWindow.Col := 116 }    
 
      DEFINE TIMER Timer_1Q INTERVAL 1000  ACTION (RELEASE MEMORY)
     
*----------------------  Routine TIMER donated by Lucho Miranda  ElSalnes@telefonica.net ---------------------*
          DEFINE TIMER Timer_1 INTERVAL 1000 ACTION ;        
                    ( Win_1.Title :="Base SQlite Photo"+ SPACE(02)+" Fecha: " + DTOC(DATE()) + ;
                     SPACE(03) + "Hora: " + TIME() )                         
*-------------------------------------------------------------------------------------------------------------* 
*------------------------------------------  Letra Titulo ----------------------------------------------------* 

     LetterShadow (014, 264 ,"01hi","02hi","Base SQLite Photo","Snap ITC",24,.T.,.T., 000,000,000, 255,234,000 )

*-------------------------------------------  End Titulo -----------------------------------------------------* 
*-------------------------------------------------------------------------------------------------------------* 
     NewBoxShadow( 079, 042, 678, 174 ,"05hi" ,"06hi","07hi", .T. , .F. , .T. , 016,000,100 , 128,126,255 )  
                      Win_1.Label_05hi.Enabled := .F.   
                      Win_1.Label_06hi.Enabled := .F.   
                      Win_1.Label_07hi.Enabled := .F.   
*-------------------------------------------------------------------------------------------------------------*
      Box( 079 , 041 , 670 , 164, "08hi",253, 209, 209  )  
                      Win_1.Label_08hi.Enabled := .F.
*-------------------------------------------------------------------------------------------------------------* 
*-------------------------------------------------------------------------------------------------------------*
  
    DEFINE LABEL Label_1
        ROW    090  
        COL    051
        WIDTH  070
        HEIGHT 020
        VALUE "Code:"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR { 253, 209, 209 }
        FONTCOLOR NIL
    END LABEL

    DEFINE TEXTBOX Text_1
        ROW    090   
        COL    140 
        WIDTH  120
        HEIGHT 024
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Code"
        ONCHANGE Nil
        ONGOTFOCUS  Win_1.Label_1.FontBold := .T.  
        ONLOSTFOCUS Win_1.Label_1.FontBold := .F.  
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONENTER Nil
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        READONLY .T.   
        RIGHTALIGN .F.
        DISABLEDBACKCOLOR {215,255,253}  
        DISABLEDFONTCOLOR {000,000,000} 
        MAXLENGTH 5
        FONTCOLOR NIL
        INPUTMASK Nil
        FORMAT Nil
        NUMERIC .T. 
        VALUE Nil
    END TEXTBOX

*-----------------------------------------------------------------*

    DEFINE LABEL Label_2
        ROW    120    
        COL    051
        WIDTH  070
        HEIGHT 020 
        VALUE "Name:"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR {253, 209, 209 } 
        FONTCOLOR NIL
    END LABEL

    DEFINE TEXTBOX Text_2
        ROW    120    
        COL    140
        WIDTH  310
        HEIGHT 024
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Name"
        ONCHANGE Nil
        ONGOTFOCUS  Win_1.Label_2.FontBold := .T.
        ONLOSTFOCUS Win_1.Label_2.FontBold := .F. 
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONENTER Nil
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        READONLY .T.
        RIGHTALIGN .F.
        DISABLEDBACKCOLOR {215,255,253}  
        DISABLEDFONTCOLOR {000,000,000} 
        MAXLENGTH 55
        FONTCOLOR NIL
        INPUTMASK Nil
        FORMAT Nil
        VALUE ""
    END TEXTBOX

*-----------------------------------------------------------------*

    DEFINE LABEL Label_3
        ROW    150    
        COL    051
        WIDTH  070
        HEIGHT 020
        VALUE "Phone:"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR {253, 209, 209 } 
        FONTCOLOR NIL
    END LABEL

    DEFINE TEXTBOX Text_3
        ROW    150  
        COL    140
        WIDTH  120
        HEIGHT 024
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Phone"
        ONCHANGE Nil
        ONGOTFOCUS  Win_1.Label_3.FontBold := .T.
        ONLOSTFOCUS Win_1.Label_3.FontBold := .F. 
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONENTER Nil
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        READONLY .T.    
        RIGHTALIGN .F.
        DISABLEDBACKCOLOR {215,255,253}  
        DISABLEDFONTCOLOR {000,000,000} 
        MAXLENGTH 9
        FONTCOLOR NIL
        INPUTMASK Nil
        FORMAT Nil
        NUMERIC .T.                 
        VALUE "0" 
    END TEXTBOX

*-----------------------------------------------------------------*

    DEFINE LABEL Label_4
        ROW    180    
        COL    051
        WIDTH  070
        HEIGHT 020
        VALUE "Date:"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR {253, 209, 209 } 
        FONTCOLOR NIL
    END LABEL

    DEFINE TEXTBOX Text_4
        ROW    180  
        COL    140
        WIDTH  120
        HEIGHT 024
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Date"
        ONCHANGE Nil
        ONGOTFOCUS  Win_1.Label_4.FontBold := .T.
        ONLOSTFOCUS Win_1.Label_4.FontBold := .F. 
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONENTER Nil
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        READONLY .T.   
        RIGHTALIGN .F.
        DISABLEDBACKCOLOR {215,255,253}  
        DISABLEDFONTCOLOR {000,000,000} 
        MAXLENGTH 10
        FONTCOLOR NIL
        INPUTMASK "99/99/9999"
        FORMAT Nil
        NUMERIC .F.                 
        VALUE DTOC(DATE())
    END TEXTBOX

*-----------------------------------------------------------------*

     DEFINE LABEL Label_5
        ROW    210    
        COL    051
        WIDTH  070
        HEIGHT 020
        VALUE "N Photo:"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR {253, 209, 209 } 
        FONTCOLOR NIL
    END LABEL 

    DEFINE TEXTBOX text_5
        ROW    210  
        COL    140
        WIDTH  120
        HEIGHT 024
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "N Photo"
        ONCHANGE Nil
        ONGOTFOCUS  Win_1.Label_5.FontBold := .T.
        ONLOSTFOCUS Win_1.Label_5.FontBold := .F. 
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONENTER Nil
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        READONLY .T.   
        RIGHTALIGN .F.
        DISABLEDBACKCOLOR {215,255,253}  
        DISABLEDFONTCOLOR {000,000,000} 
        MAXLENGTH 10
        FONTCOLOR NIL
        INPUTMASK "99999" 
        FORMAT Nil
        NUMERIC .F.                 
        VALUE "00000"  
    END TEXTBOX

*---------------------------------------------------------------------*

    DEFINE LABEL Label_6
        ROW    150
        COL    357
        WIDTH  080
        HEIGHT 020
        VALUE "Married:"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR { 253, 209, 209 }  
        FONTCOLOR NIL
    END LABEL 

    DEFINE TEXTBOX Text_6
        ROW    180  
        COL    357
        WIDTH  040
        HEIGHT 024
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Married"
        ONCHANGE Nil
        ONGOTFOCUS  Win_1.Label_6.FontBold := .T.
        ONLOSTFOCUS( If (.NOT.(This.Value $ "YESNOYesNo") , EVAL({|| This.SetFocus, This.Value:= 'NO'}), NIL ) , Win_1.Label_6.FontBold := .F. )
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONENTER Nil
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        READONLY .T.   
        RIGHTALIGN .F.
        DISABLEDBACKCOLOR {215,255,253}  
        DISABLEDFONTCOLOR {000,000,000} 
        MAXLENGTH 3
        FONTCOLOR NIL
        INPUTMASK NIL
        FORMAT Nil
        NUMERIC .F.                 
        VALUE "No"
    END TEXTBOX

*---------------------------------------------------------------------*
 
    DEFINE LABEL Edit1
        ROW    087    
        COL    357 
        WIDTH  070
        HEIGHT 020
        VALUE "Notes:"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR {253, 209, 209 } 
        FONTCOLOR NIL
    END LABEL

    DEFINE EDITBOX Edit_1
        ROW    090
        COL    467 
        WIDTH  235 
        HEIGHT 142  
        VALUE ""
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Notes"
        ONCHANGE Nil
        ONGOTFOCUS  Win_1.Edit1.FontBold := .T.
        ONLOSTFOCUS Win_1.Edit1.FontBold := .F. 
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        READONLY .T.
        HSCROLLBAR .F.
        VSCROLLBAR .T.
        DISABLEDBACKCOLOR {215,255,253}  
        DISABLEDFONTCOLOR {000,000,000} 
        FONTCOLOR Nil
    END EDITBOX

*---------------------------------------------------------------------*
*---------------------- Ordenado por:---------------------------------*
*---------------------------------------------------------------------*

   MiFrame( 090,810,180,083,"frame_00","Sort by",{007 ,002 , 204},{ 031,154,108 } )   

    DEFINE LABEL Label_7
        ROW    060
        COL    870   
        WIDTH  100 
        HEIGHT 024
        VALUE "Sort by:"         //<---------- "Ordenado por:"
        FONTNAME "Arial"
        FONTSIZE 11
        TOOLTIP ""
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR { 031,154,108 }   
        FONTCOLOR NIL
    END LABEL

    DEFINE RADIOGROUP RadioGroup_1  
        ROW    100  
        COL    887 
        WIDTH  100
        HEIGHT 050
        OPTIONS {'Code','Name'}      
        VALUE 1
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Code Name"
        ONCHANGE vnombre_radiogroup_1_onchange()
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        TRANSPARENT .F.
        SPACING 25
        BACKCOLOR { 031,154,108 } 
        FONTCOLOR NIL
        READONLY Nil
        HORIZONTAL .F. 
    END RADIOGROUP

    DEFINE IMAGE Radio_1
         ROW    108
         COL    842   
         WIDTH  030 
         HEIGHT 039 
         PICTURE "resource\ONxx.jpg"   
         HELPID Nil
         VISIBLE .T.
         STRETCH .F.
         ACTION Nil
     END IMAGE

    DEFINE IMAGE Radio_2
         ROW    108
         COL    842  
         WIDTH  030 
         HEIGHT 039
         PICTURE "resource\OFFxx.jpg"   
         HELPID Nil
         VISIBLE .F.
         STRETCH .F.
         ACTION Nil
     END IMAGE


*--------------------------------------------------------------------------------------------------------------------------------*
*--------------------------------------------------------------  Grid -----------------------------------------------------------*
*--------------------------------------------------------------------------------------------------------------------------------*

    Private Salmon  := { || IIF( This.CellRowIndex / 2 == INT( This.CellRowIndex / 2 ), { 255, 202, 149 } , { 080, 240, 006 } ) } //<--- Color Columna
    Private fColor  := { || if ( This.CellRowIndex/2 == int(This.CellRowIndex/2) , BLUE , YELLOW ) }                             // <---- Color Letras  
*--------------------------------------------------------------------------------------------------------------------------------*                                
    NewBoxShadow( 280, 042, 678, 247 ,"09hi" ,"10hi","11hi", .T. , .F. , .T., 016,000,100 , 128,126,255 ) //.T. , .F. , .T

                     Win_1.Label_09hi.Enabled := .F.    
                     Win_1.Label_10hi.Enabled := .F.   
                     Win_1.Label_11hi.Enabled := .F.    
*--------------------------------------------------------------------------------------------------------------------------------* 
    Box( 280 , 041 , 670 , 237, "12hi",251 , 134 ,002 )     
                     Win_1.Label_12hi.Enabled := .F.
*--------------------------------------------------------------------------------------------------------------------------------* 
*-------------------------- Cabecera GRid_1 ---------------------------------------*
       DEFINE IMAGE Fondo_1
           ROW 290 ; COL 052 ; WIDTH 650 ; HEIGHT 025          
           PICTURE  "Resource\cabecera2.jpg"      
           STRETCH .T.
       END IMAGE
*----------------------------------------------------------------------------------*
*------------------------------- Color Barra Video Inversa ------------------------*
  _HMG_SYSDATA [ 348 ] := { 199,250,225 }    
  _HMG_SYSDATA [ 349 ] := { 007,071,041 }   
  _HMG_SYSDATA [ 350 ] := { 235,237,095 }   
  _HMG_SYSDATA [ 351 ] := { 069,015,135 }  
*----------------------------------------------------------------------------------*

     DEFINE GRID Grid_1  
        ROW    315      
        COL    051 
        WIDTH  651              
        HEIGHT 193    
        ITEMS aGrid                             
        VALUE 1
        WIDTHS  { 080,260,110,110,070,0,0 }          // 0 <----  porque asi no sale en Grid  0   <--- because that's not in Grid 
        HEADERS {"Code", "Name", "Phone", "Date", "Married", "", ""}    
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        ONCHANGE vnombre_grid_1_onchange()
        ONGOTFOCUS Nil
        ONLOSTFOCUS Nil
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONDBLCLICK Apoyox_2()  
        ONHEADCLICK Nil
        ONQUERYDATA Nil
        MULTISELECT .F.
        ALLOWEDIT .F.
        VIRTUAL .F. 
        DYNAMICFORECOLOR { fcolor , fcolor , fcolor , fcolor , fcolor , fcolor , fcolor } 
        DYNAMICBACKCOLOR { Salmon , Salmon , Salmon , Salmon , Salmon , Salmon , Salmon }
        COLUMNWHEN Nil
        COLUMNVALID Nil
        COLUMNCONTROLS Nil
        SHOWHEADERS .F.       //  <---- Columnas Frucen ( Congeladas ) 
        CELLNAVIGATION .F.    
        NOLINES .F.
        HELPID Nil
        IMAGE Nil
        JUSTIFY { GRID_JTFY_RIGHT , GRID_JTFY_LEFT , GRID_JTFY_LEFT , GRID_JTFY_LEFT , GRID_JTFY_LEFT , GRID_JTFY_LEFT  , GRID_JTFY_LEFT } 
        ITEMCOUNT Nil
        BACKCOLOR { 209,238,238 }
        FONTCOLOR { 000,255,020 } 
        HEADERIMAGES Nil
        ROWSOURCE Nil
        COLUMNFIELDS Nil
        ALLOWAPPEND .F.
        ALLOWDELETE .F.
        BUFFERED .F.
        DYNAMICDISPLAY Nil
        ONSAVE Nil
        LOCKCOLUMNS 0
     END GRID

*---------------------------------------------------------------------* 
*---------------------------------  Photo  ---------------------------*
*---------------------------------------------------------------------* 

     DEFINE LABEL lab_photo
        ROW    182  
        COL    885  
        WIDTH  070
        HEIGHT 020
        VALUE "Photo:"
        FONTNAME "Arial"
        FONTSIZE 10
        TOOLTIP ""
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR { 031,154,108 } 
        FONTCOLOR NIL
     END LABEL

*------------------------------------------------------------------------------------------------------------------*
       BoxShadow(220, 766, 309, 309 ,"02a" ,"02aX", 255 , 255 ,255 ) 
                     Win_1.Label_02a.Enabled  := .F.   
                     Win_1.Label_02aX.Enabled := .F.   
*------------------------------------------------------------------------------------------------------------------*                    
      DEFINE IMAGE ImagePhoto 
           ROW 219 ; COL 765 ; WIDTH 300 ; HEIGHT 300
           PICTURE "Photo\00000.jpg"                 
           STRETCH .T.
      END IMAGE
*---------------------------------------------------------------------*
*------------------------------- Search ------------------------------*
*---------------------------------------------------------------------*
 
    MiFrame( 612,045,500,60,"Frame_02","Search",{007 ,002 , 204},{ 031,154,108 } )    

    DEFINE LABEL  Label_Search 
        ROW    633 
        COL    058  
        WIDTH  050
        HEIGHT 020
        VALUE "Search:"
        FONTNAME "Arial"
        FONTSIZE 11   
        TOOLTIP ""
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR { 031,154,108 }
        FONTCOLOR NIL
    END LABEL

    DEFINE IMAGE Radio_3
         ROW    620
         COL    116
         WIDTH  030 
         HEIGHT 039 
         PICTURE "resource\ONxx.jpg"   
         HELPID Nil
         VISIBLE .T.
         STRETCH .F.
         ACTION Nil
    END IMAGE

    DEFINE IMAGE Radio_4
         ROW    620 
         COL    116 
         WIDTH  030 
         HEIGHT 039
         PICTURE "resource\OFFxx.jpg"   
         HELPID Nil
         VISIBLE .F.
         STRETCH .F.
         ACTION Nil
    END IMAGE

    DEFINE RADIOGROUP RadioGroup_2
        ROW    615  
        COL    166 
        WIDTH  050  
        HEIGHT 005  
        OPTIONS {'Code','Name'}      
        VALUE 1
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Code , Name"
        ONCHANGE vnombre_radiogroup_2_onchange()
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        TRANSPARENT .F.
        SPACING 25
        BACKCOLOR { 031,154,108 } 
        FONTCOLOR NIL
        READONLY Nil
        HORIZONTAL .F. 
    END RADIOGROUP
 
    DEFINE TEXTBOX txtSearch  
        ROW    630  
        COL    237  
        WIDTH  297 
        HEIGHT 024
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Search by code or by Name"   //--->  "Busqueda por Cdigo o por Nombre"
        ONCHANGE SearchData() 
        ONGOTFOCUS Nil
        ONLOSTFOCUS Nil
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONENTER Nil
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        READONLY .F.   
        RIGHTALIGN .F.
        DISABLEDBACKCOLOR Nil
        DISABLEDFONTCOLOR Nil
        MAXLENGTH 40
        BACKCOLOR  { 253, 209, 209 } 
        FONTCOLOR NIL
        INPUTMASK Nil
        FORMAT Nil
        NUMERIC .F.                 
        VALUE ""
    END TEXTBOX
*--------------------------------- N Records -------------------------*

     MiFrame( 617,590,130,51,"Frame_03","Records Database",{007 ,002 , 204},{ 031,154,108 } )   

     @ 633, 632 Label Label_2G              ;
                WIDTH   080                 ;  
                HEIGHT  025                 ;
                FONT "Arial"  SIZE 13 BOLD  ;
                BACKCOLOR { 031,154,108 }   ;
                FONTCOLOR { 000,000,000 }   ;
                VALUE ""

*---------------------------------------------------------------------*

   PRIVATE nCode := HB_UCODE("&")
   PRIVATE nDece := "Miscellaneous "+ "&" + HB_UCHAR(nCode) + " Up-Down"

   MiFrame( 542,133,488,56,"frame_01", nDece ,{007 ,002 , 204},{ 031,154,108 } )   
  
*---------------------------------------------------------------------*
*-----------------------------  BUTTONS ------------------------------*
*---------------------------------------------------------------------*
  
     DEFINE BUTTON  Bnuevo
        ROW    550 
        COL    143   
        WIDTH  043
        HEIGHT 043  
        ACTION  Apoyox_1() 
        TOOLTIP "New"
        PICTURE "resource/cmdIncluir.ico"
    END BUTTON

    DEFINE BUTTON Bmodificar
        ROW    550 
        COL    186
        WIDTH  043
        HEIGHT 043
        ACTION  Apoyox_2()  
        TOOLTIP "Change"
        PICTURE "resource/cmdAlterar.ico"  
    END BUTTON

    DEFINE BUTTON Beliminar
        ROW    550  
        COL    229 
        WIDTH  043
        HEIGHT 043
        ACTION  vnombre_beliminar_action()   
        TOOLTIP SPACE(5)-"Delete"
        PICTURE "Resource/cmdExcluir.ico" 
    END BUTTON

    DEFINE BUTTON Bimprime
        ROW    550  
        COL    272  
        WIDTH  043
        HEIGHT 043 
        ACTION mPrinting()     
        TOOLTIP "List by Code or by Name"
        PICTURE "Resource/cmdImprimir.ico"   
    END BUTTON

    DEFINE BUTTON PaswordX
        ROW    550  
        COL    315 
        WIDTH  043  
        HEIGHT 043  
        ACTION NewClave()   
        TOOLTIP "New Key"   
        PICTURE "Resource/cmdExport.ico"  
    END BUTTON

    DEFINE BUTTON House
        ROW    550  
        COL    358 
        WIDTH  043  
        HEIGHT 043  
        ACTION AboutX()
        TOOLTIP "About ..." 
        PICTURE "Resource/cmdSair.ico"  
    END BUTTON

*----------------------------------------------------------------------------------------------------*

    DEFINE BUTTON Bsalir
        ROW    565
        COL    858
        WIDTH  105
        HEIGHT 053
        ACTION FinalProgram()   
        CAPTION SPACE(5)-"Exit"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Exit"
        FONTBOLD .T.
        FONTITALIC .F.
        PICTURE "Resource/Exit.Bmp"
        PICTALIGNMENT LEFT
    END BUTTON

*----------------------------------------------------------------------------------------------------*

    DEFINE BUTTON But_01
         ROW    550   
         COL    441 
         WIDTH  043
         HEIGHT 043
         PICTURE "Resource/cmdPrimeiro.ico"
         TOOLTIP 'First'
         ACTION GoFirst()   
    END BUTTON

    DEFINE BUTTON But_02
         ROW    550  
         COL    484
         WIDTH  043
         HEIGHT 043
         PICTURE "Resource/cmdAnterior.ico"  
         TOOLTIP 'Previous'
         ACTION GoPrevious()
    END BUTTON

    DEFINE BUTTON But_03
         ROW    550
         COL    527
         WIDTH  043
         HEIGHT 043
         PICTURE "Resource/cmdSeguinte.ico"  
         TOOLTIP 'Next'
         ACTION GoNext()   
    END BUTTON

    DEFINE BUTTON But_04
         ROW    550 
         COL    570
         WIDTH  043
         HEIGHT 043
         PICTURE "Resource/cmdUltimo.ico" 
         TOOLTIP 'Last'
         ACTION GoLast()
    END BUTTON

*-------------------------------------------------------------------------------------*
*------------------------------------- End  Up-Down  ---------------------------------*
*-------------------------------------------------------------------------------------*

  END WINDOW

  SETWINDOWCURSOR ( Win_1.bnuevo.Handle, "Resource\SmoothHand.cur")

  Win_1.txtSearch.SetFocus   

  Win_1.Center
  Win_1.Activate

Return

*----------------------------------------------------------------------------------------*
*----------------------------------------------------------------------------------------*

*-------------------------------------------*
Function main_button_1_action()
*-------------------------------------------*
 
 public dbo := nil

 if .not. file("nombre.db3")
     crearbase("nombre.db3")
     msginfo("Base Created")   //<----------- ("Base Creada") 
     return nil
  else
   dbo := connect2db("nombre.db3",.F.)
    If dbo == nil
       msginfo("can not connect to the Base")    //<------ ("no se puede conectar con la Base")
      return nil
    Endif
 endif   

 datossqlite()

*-------------------------------------------*
Function crearbase(mDb)
*-------------------------------------------*

*----------------------------------------------------------------------------------------------------*

 * miscsql always require two parameters. First one is dbo object and the next one is the query. 
 * When creating a database, we have to use connect2db with .T. as the second parameter. 
 * I hope this helps.
 * Rathinagiri

 * miscsql siempre requiere dos parmetros. El primero es objeto dbo y la siguiente es la consulta. 
 * Al crear una base de datos, tenemos que usar con connect2db  .T. como el segundo parmetro.
 * Espero que esto ayude.
 * Rathinagiri 

*----------------------------------------------------------------------------------------------------*

  local sQry
  local lOk := .f.

  sQry := "CREATE TABLE IF NOT EXISTS personales (id INTEGER PRIMARY KEY, nombre VARCHAR(55),telefono VARCHAR(15), fecha VARCHAR(10), Married VARCHAR(6), notas VARCHAR(80),PHOTO VARCHAR(15) );"  

  dbo := connect2db(mDb, .t.)
  lOk := miscsql(dbo,sQry)

return nil  

*-------------------------------------------*
Function datossqlite()
*-------------------------------------------*

   local aTable := {}
   private lModify := .f.

   if dbo == nil
     return nil
   endif

   Win_1.Grid_1.deleteallitems()

        aTable := sql(dbo,"SELECT id, nombre, telefono, fecha , Married , notas , PHOTO FROM personales ORDER BY  id")

   if len(aTable) > 0

     for i := 1 to len(aTable)
       Win_1.Grid_1.additem({str(aTable[i,1]),UPPER(aTable[i,2]),aTable[i,3], aTable[i,4],aTable[i,5],aTable[i,6],aTable[i,7]})
    next i 
 
    Win_1.Grid_1.value := 1

   endif   

  Return Nil

*-------------------------------------------*
 Function vnombre_grid_1_onchange()
*-------------------------------------------*
  PRIVATE xaline :={}
  PRIVATE xaReturnX_Sql
  PRIVATE xaDataRecordX
  PRIVATE xnToRecords
  PRIVATE cQuery_
  PRIVATE xnumeRt 
*------------------------------------------*
  dbo := connect2db("control.db3",NIL)    // <-----------------  Desconectar Base de Control
  dbo := connect2db("nombre.db3",.T.)     //  <----------------- Conectar Base de Clientes
*------------------------------------------*

 xnToRecords := 0

 cQuery_ := "SELECT id, nombre, telefono, fecha , Married, notas, PHOTO FROM personales ORDER BY  id" 

 xaReturnX_Sql := Sqlite_Cmd( dbo, cQuery_  )

 FOR EACH xaDataRecordX IN xaReturnX_Sql
      ID := xaDataRecordX[ 1 ]
            xnToRecords ++
  NEXT  xaDataRecordX

  xnumeRt :=  xnToRecords ++
  
   If Win_1.Grid_1.value > 0        

     xaline := Win_1.Grid_1.item(Win_1.Grid_1.value)
                   
     Win_1.Label_2G.value    := ALLTRIM( xaline[1] ) + space(1)+"/"+space(1)+ ALLTRIM(STR(( xnumeRt )))     // Nmero de Registros

     Win_1.text_1.value       :=     Val(xaline[1])                            // Code
     Win_1.text_2.value       :=   UPPER(xaline[2])                            // Name
     Win_1.text_3.value       :=     Val(xaline[3])                            // Phone     
     Win_1.text_4.value       :=         xaline[4]                             // Date
     Win_1.text_6.value       :=         xaline[5]                             // Married
     Win_1.Edit_1.value       :=         xaline[6]                             // Notes
     Win_1.text_5.value       := SUBSTR( xaline[7],7,5)                        // Num Photo  
     Win_1.ImagePhoto.Picture := ("Photo\"+ SUBSTR( xaline[7],7,5)+".jpg")     // Photo
   Endif
      
 Return 

*-------------------------------------------*
 Function vnombre_radiogroup_1_onchange()
*-------------------------------------------*
*-------------------------------------------*
  dbo := connect2db("control.db3",NIL)     // <-----------------  Desconectar Base de Control
  dbo := connect2db("nombre.db3",.T.)     //  <----------------- Conectar Base de Clientes
*-------------------------------------------*

   Win_1.txtSearch.Value := ""    
   Win_1.Grid_1.deleteallitems()

   DO CASE
      CASE  Win_1.radiogroup_1.value = 1   

                Win_1.Radio_1.VISIBLE := .T.
                Win_1.Radio_2.VISIBLE := .F.

                Win_1.RadioGroup_2.value := 1  

                Win_1.Radio_3.VISIBLE := .T.
                Win_1.Radio_4.VISIBLE := .F.

                Win_1.txtSearch.Value := ""    
                Win_1.Grid_1.deleteallitems()

                aTable := sql(dbo,"SELECT id, nombre, telefono, fecha , Married, notas, PHOTO FROM personales ORDER BY  id")
           
      CASE  Win_1.radiogroup_1.value = 2  

                Win_1.Radio_1.VISIBLE := .F.
                Win_1.Radio_2.VISIBLE := .T.

                Win_1.RadioGroup_2.value := 2  

                Win_1.Radio_3.VISIBLE := .F.
                Win_1.Radio_4.VISIBLE := .T.

                Win_1.txtSearch.Value := ""    
                Win_1.Grid_1.deleteallitems()

                aTable := sql(dbo,"SELECT id, nombre, telefono, fecha , Married, notas, PHOTO FROM personales ORDER BY  nombre")
           
   ENDCASE
    
   IF Win_1.radiogroup_1.value = 1   
      FileDelete ('controlM.mem')
      nOrder := 1
      SAVE TO controlM.mem ALL LIKE nOrder*
   ELSE
      FileDelete ('controlM.mem')
      nOrder := 2
      SAVE TO controlM.mem ALL LIKE nOrder*
   ENDIF

   if len(aTable) > 0
 
     Win_1.Grid_1.deleteallitems()
  
     for i := 1 to len(aTable)
         Win_1.Grid_1.additem({str(aTable[i,1]),UPPER(aTable[i,2]),aTable[i,3],aTable[i,4],aTable[i,5],aTable[i,6],aTable[i,7]})
     next i  
 
     Win_1.Grid_1.value := 1

  endif  
 
    Win_1.Grid_1.value := 1

 Return Nil

*-------------------------------------------*
 Function vnombre_radiogroup_2_onchange()
*-------------------------------------------*
*-------------------------------------------*
  dbo := connect2db("control.db3",NIL)     // <-----------------  Desconectar Base de Control
  dbo := connect2db("nombre.db3",.T.)      //  <----------------- Conectar Base de Clientes
*-------------------------------------------*


   Win_1.txtSearch.Value := ""  
   Win_1.Grid_1.deleteallitems()

   DO CASE
       CASE  Win_1.radiogroup_2.value = 1   

                Win_1.Radio_1.VISIBLE := .T.
                Win_1.Radio_2.VISIBLE := .F.
   
                Win_1.RadioGroup_1.value := 1  

                Win_1.Radio_3.VISIBLE := .T.
                Win_1.Radio_4.VISIBLE := .F.

                Win_1.txtSearch.Value := ""    
                Win_1.Grid_1.deleteallitems()
        
                aTable := sql(dbo,"SELECT id, nombre, telefono, fecha , Married, notas, PHOTO FROM personales ORDER BY  id")

       CASE  Win_1.radiogroup_2.value = 2   

                Win_1.Radio_1.VISIBLE := .F.
                Win_1.Radio_2.VISIBLE := .T.

                Win_1.RadioGroup_1.value := 2  
              
                Win_1.Radio_3.VISIBLE := .F.
                Win_1.Radio_4.VISIBLE := .T.

                Win_1.txtSearch.Value := ""    
                Win_1.Grid_1.deleteallitems()
       
                aTable := sql(dbo,"SELECT id, nombre, telefono, fecha , Married, notas, PHOTO FROM personales ORDER BY  nombre")

    ENDCASE

   If len(aTable) > 0           // Posible ERROR habra que anular ?

    Win_1.Grid_1.deleteallitems()
  
    for i := 1 to len(aTable)
       Win_1.Grid_1.additem({str(aTable[i,1]),UPPER(aTable[i,2]),aTable[i,3],aTable[i,4],aTable[i,5],aTable[i,6],aTable[i,7]})
    next i   
   
    Win_1.Grid_1.value := 1
   
   Endif   

Return Nil

*------------------------------------------------------------*
 FUNCTION Select_Photo()
*------------------------------------------------------------*

	PUBLIC PhotoFile , Nuevo ,  ficherAaX 
        PUBLIC aFilters := { {'jpg Files','*.jpg'} }
	
	PhotoFile := Getfile ( { {'All Files','*.*'} } , 'Select Photo' , 'PHOTO\' , .F. , .T. )             

*---------------------------------------------------------------------------------------------------*
        ficherAaX := RIGHT( PhotoFile , LEN(PhotoFile) - RAT("\", PhotoFile ))  
*------------------------------ calcula Longitud Fichero jpg ---------------------------------------*
        Nuevo =  LEFT (ficherAaX, LEN( ficherAaX ) - 4 ) 
        SAVE TO Photo_Num ALL LIKE Nuevo   
*--------------------------------------------- View Changes Photo  ---------------------------------*

   IF IsWindowDefined( Form_2 )
      Declare window Form_2
      RESTORE FROM Photo_Num.mem ADDITIVE
      Form_2.Mostraryx.Picture := "Photo\"+ALLTRIM(Nuevo)+".jpg"    
      Form_2.Control_6.value := ALLTRIM(NUEVO)

   IF NUEVO == ""
      Form_2.Control_6.value := "00000" 
   ENDIF
  
      Declare Window Win_1

  ENDIF

*----------------------------------------------------------------------------------------------------*

   PRIVATE aLine := {}
   PRIVATE cName := ""

   aline := Win_1.Grid_1.item(Win_1.Grid_1.value)
   cName := aLine[1]
 
  IF IsWindowDefined( Form_2x )
     declare window Form_2x
     RESTORE FROM Photo_Num.mem ADDITIVE
     Form_2x.Mostrary.Picture := "Photo\"+ALLTRIM(Nuevo)+".jpg"     
     Form_2x.Control_6x.value := ALLTRIM(NUEVO)

   IF NUEVO == ""
      Form_2X.Control_6X.value := SUBSTR( aline[7],7,5)  
   ENDIF

   Declare Window Win_1

  ENDIF
     
  Return Nil

*-------------------------------------*
 Function vnombre_baceptar_action()
*-------------------------------------*

   Declare Window Form_2

   PUBLIC cNewRecNo       

   aTable := sql( dbo, 'select max( id ) from personales where not id = ' + c2sql( '41118000' ) )

   if len( aTable ) > 0
      cNewRecNo := alltrim(str((val(aTable[ 1, 1 ])+1)))
   endif

   if empty( Form_2.Control_1.value )
      msgstop("You must enter Data!", "Error")       // ("Debe ingresar un Dato!","Error")
          Form_2.Control_1.setfocus()
      return nil
   endif

   if len(Alltrim( Form_2.Control_2.value )) == 0               
       msgstop("You must enter Data!", "Error")       //("Debe ingresar un Dato!","Error")
           Form_2.Control_2.setfocus() 
      return nil
    endif

*------------------------------------------- Seleccin de Photo -----------------------------------*
         IF Form_2.Control_6.value == "00000" .OR. Form_2.Control_6.value == ""
                         RESTORE FROM Photo_Num.mem ADDITIVE
         ELSE
                         Nuevo =  Form_2.Control_6.value
                         SAVE TO Photo_Num ALL LIKE Nuevo 
         ENDIF
*--------------------------------------------------------------------------------------------------*
          IF Nuevo == ""
                        Nuevo =  "00000"
                        SAVE TO Photo_Num ALL LIKE Nuevo 
          ENDIF

                        RESTORE FROM Photo_Num.mem ADDITIVE
*--------------------------------------------------------------------------------------------------*
        
      lOk := miscsql(dbo, "insert into personales (id,nombre,telefono,fecha,Married,notas,PHOTO) values ("+;
                                                  c2sql(cNewRecNo)                      +", "+;                        
                                            UPPER(c2sql(Form_2.Control_2.value))        +", "+;
                                                  c2sql(VAL(Form_2.Control_3.value))    +", "+;
                                                  c2sql(Form_2.Control_4.value)         +", "+; 
                                            UPPER(c2sql(Form_2.Control_5.value))        +", "+;   
                                                  c2sql(Form_2.Edit_11.value)           +", "+;  
                                                  c2sql("Photo\"+ALLTRIM( Nuevo)+".jpg")+")")

      datossqlite()


 Return Nil


*-------------------------------------------*
 Function vnombre_bmodificar_action()
*-------------------------------------------*

   local aLine := {}
   local cName := ""


   aline := Win_1.Grid_1.item(Win_1.Grid_1.value)
   cName := aLine[1]
 

   declare window Form_2x 

   if len(alltrim(Form_2x.Control_2x.value)) == 0               
       msgStop("You must enter Data!", "Error")        //---> ("Debe ingresar un Dato!","Error")
       return nil
   endif     

*------------------------------------------- Seleccin de Photo -----------------------------------*
        IF Form_2x.Control_6x.value == "00000" .OR. Form_2x.Control_6x.value == ""

                         RESTORE FROM Photo_Num.mem ADDITIVE
           ELSE 
                         Nuevo =  Form_2x.Control_6x.value
                         SAVE TO Photo_Num ALL LIKE Nuevo 
        ENDIF
*--------------------------------------------------------------------------------------------------*
          IF Nuevo == ""

                        Nuevo =  "00000"

                        SAVE TO Photo_Num ALL LIKE Nuevo 
          ENDIF
  
         RESTORE FROM Photo_Num.mem ADDITIVE

*--------------------------------------------------------------------------------------------------*

      lOk := miscsql(dbo,"update personales set "+;
                    "id       =       "+c2sql(Form_2x.Control_1x.value) +", "+;
                    "nombre   = "+UPPER(c2sql(Form_2x.Control_2x.value))+", "+;
                    "telefono =       "+c2sql(Form_2x.Control_3x.value) +", "+;
                    "fecha    =       "+c2sql(Form_2x.Control_4x.value) +", "+;                               
                    "Married  =       "+c2sql(Form_2x.Control_5x.value) +", "+;  
                    "Notas    =       "+c2sql(Form_2x.Edit_11x.value)   +", "+;            
                    "PHOTO    =       "+c2sql("Photo\"+ ALLTRIM( Nuevo) +".jpg")+;
                    "where id =       "+c2sql(cName) )

      datossqlite()

  Return Nil

*----------------------------------*
Function vnombre_beliminar_action()
*----------------------------------*

 local nLineNo := 0
 local aLine := {}

   if Win_1.Grid_1.value > 0
      nLineNo := Win_1.Grid_1.value
      aLine   := Win_1.Grid_1.item(Win_1.Grid_1.value) 

       If MsgYesNo( "Proceed to remove the Record ?"+ CRLF + CRLF + ;           //Confirma la eliminacin del registro?
                    "Code:  "+ SPACE(1)+(c2sql(aLine[1])) + CRLF + ;  
                    "Name:  "+   alltrim(c2sql(aLine[2])) + CRLF + ;
                    "Phone: "+ SPACE(1)+alltrim(c2sql(aLine[3])) + CRLF + ;
                    "Date:  "+ SPACE(3)+(c2sql(aLine[4])) ,"Delete Records" )

        lOk := miscsql(dbo,"delete from personales where id = "+c2sql(aLine[1]))

        sqlite3_exec(dbo,"VACUUM")                          //    <-----------  Equivale a PACK
  *     sqlite3_exec(dbo,"VACUUM"== c2sql(aLine[1]))       // Ojo <------------ Borra Toda la Base de Datos
 
         if .not. lOk
            msgstop("Operacin no realizada","Mensaje")
            return nil
         endif

         Win_1.Grid_1.deleteitem(nLineNo)

         if nLineNo > 1
            Win_1.Grid_1.value := Win_1.Grid_1.value - 1
         else
            if Win_1.Grid_1.itemcount > 0
               Win_1.Grid_1.value := 1
            endif
         endif
      endif
   endif

   datossqlite()

 Return Nil

*----------------------------------*
Function SearchData()
*----------------------------------*

  local s, tmp , aTableM , aTableN 

  IF Win_1.radiogroup_2.value = 1   

        aTableM := sql(dbo,"SELECT id, nombre, telefono, fecha , Married FROM personales ORDER BY id")

	s = Win_1.txtSearch.value

        tmp := ascan(aTableM, {|x| left(STR(x[1]), len(s)) == s}) 

	if tmp > 0
		 Win_1.Grid_1.value := tmp
	endif

   ELSE

 *-------------------------------------------  Search por Nombre -------------------------------------*
      
        aTableN := sql(dbo,"SELECT id, nombre, telefono, fecha , Married FROM personales ORDER BY nombre")

	s = upper(alltrim(Win_1.txtSearch.value))

        tmp := ascan(aTableN, {|x| left(upper(alltrim(x[2])), len(s)) = s}) 

	if tmp > 0
		 Win_1.Grid_1.value := tmp
	endif

 ENDIF

Return Nil

*---------------------------------------------------------*
 Function GoFirst()
*---------------------------------------------------------*

   Win_1.Grid_1.value := 1

 return nil

*---------------------------------------------------------*
 Function GoPrevious()
*---------------------------------------------------------*

   if win_1.Grid_1.value > 1
      Win_1.Grid_1.value := Win_1.Grid_1.value - 1
   endif
 return nil

*---------------------------------------------------------*
 Function GoNext()
*---------------------------------------------------------*

   if win_1.Grid_1.value < Win_1.Grid_1.itemcount
      Win_1.Grid_1.value := Win_1.Grid_1.value + 1
   endif

 return nil
*---------------------------------------------------------*
 Function GoLast()
*---------------------------------------------------------*

   Win_1.Grid_1.value := Win_1.Grid_1.itemcount

 return nil

*-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-*

*--------------------------------------------------------*
Function CreateZip()
*--------------------------------------------------------*

  PRIVATE aDir   := Directory( "*.db3", "D" ), aFiles:= {}, nLen
  PRIVATE cPathx := HB_Curdrive()+":\"+Rtrim(Curdir() ) 

        For x:=1 to len(aDir)
	    aadd(afiles,adir[x,1])
	next

       COMPRESS aFiles ;
	       	TO 'Backup_Files\Zip_Seg.Zip' ;
		BLOCK {|| NIL }  ;
		LEVEL 9 ;
		PASSWORD ALLTRIM(  cKey  )  ;
		OVERWRITE ;
		RESULT lSuccess


  FileDelete ("Backup_Files\*.db3")

  IF File("Backup_Files\Zip_Seg.Zip")
     md5string := hb_md5file("backup_files\Zip_Seg.Zip")
     x := fcreate("Backup_Files\Zip_Seg.md5")
     fwrite(x,md5string)
     fclose(x)
  ENDIF 

 Return nil

*--------------------------------------------------------*
Function RescueZip()
*--------------------------------------------------------*

  IF ! File("Backup_Files\Zip_Seg.md5")
       msginfo("Error,Missing file 'Zip_Seg.md5' ","Error Check !!!")
    ELSE
     md5string := hb_md5file("Backup_Files\Zip_Seg.zip")
     x := Fopen("Backup_Files\Zip_Seg.md5")
     md5read := freadstr(x,32)
     fclose(x)
      IF md5read <> md5string
          msginfo("Error,Missing file 'Zip_Seg.zip' or is Altered","Error Check !!!")
          QUIT
      ELSE
          UnPackZip()
      ENDIF
  ENDIF    

 Return Nil

*--------------------------------------------------------*
Function UnPackZip()
*--------------------------------------------------------*

  PRIVATE filesX:=  "Backup_Files\Zip_Seg.zip"

  DIRCHANGE(  PriNc  )                     

               UNCOMPRESS filesX   ;  
                        BLOCK {|| NIL } ;
			PASSWORD ALLTRIM( cKey ) ;   
			RESULT lSuccess 

*--------------------------------------------------------*

   DIRCHANGE( DirZY) 

        cMyFile1 := "control.db3"
        aDir1xZ1 := "control.db3"
        cMyFile2 := "nombre.db3"
        aDir1xZ2 := "nombre.db3"
        cMyFile3 := "datetime.db3"
        aDir1xZ3 := "datetime.db3"

        path := "..\"
        COPY FILE( cMyFile1 ) TO ( path + aDir1xZ1 )
        COPY FILE( cMyFile2 ) TO ( path + aDir1xZ2 )
        COPY FILE( cMyFile3 ) TO ( path + aDir1xZ3 )
*--------------------------------------------------------*

   FileDelete("control.db3")
   FileDelete("nombre.db3")
   FileDelete("datetime.db3")

   FileDelete ("Backup_Files\Zip_Seg.md5")
   FileDelete ("Backup_Files\Zip_Seg.zip")
 
   DIRCHANGE(  PriNc  )     

   FileDelete ('Photo_Num.mem')
   FileDelete ('Photox_Num.mem')

   Nuevo  =  "00000"
   SAVE TO Photo_Num.mem ALL LIKE Nuevo 
   Nuevox =  "00000"
   SAVE TO Photox_Num.mem ALL LIKE Nuevox 
            
 Return nil

*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*

*--------------------------------------------------------*
 Function FinalProgram_2()
*--------------------------------------------------------*
      hb_gcall( .T. )
      FileDelete("datetime.dbf")
     ( CreateZip() , DeleteBasexD() )
       Win_1.Release
       Return .T.

 Return Nil 

*--------------------------------------------------------*
 Function FinalProgram()
*--------------------------------------------------------*
      hb_gcall( .T. )
 FileDelete("datetime.dbf")
      Preparando()

     ( CreateZip() , DeleteBasexD() )
       Win_1.Release
       Return .T.

 Return Nil 

*--------------------------------------------------------*
Function DeleteBasexD()
*--------------------------------------------------------*

  PRIVATE lOky 
        dbo := connect2db("nombre.db3",nil) 
        lOky := miscsql(dbo,'delete from personales where nombre <> "" ')   

     if empty(dbo)
         return .f.
    else
        sqlite3_exec(dbo,"VACUUM")   // borra toda la Base de Datos 
        hb_gcall( .t. )
 
   endif

*----------------------------------------------------------------------*

  PRIVATE lOkyQ 
        dbo := connect2db("control.db3",nil) 
        lOkyQ := miscsql(dbo,'delete from control where NAME <> "" ')   

    if empty(dbo)
        return .f.
    else
       sqlite3_exec(dbo,"VACUUM")   // borra toda la Base de Datos
        hb_gcall( .t. )

    endif
*----------------------------------------------------------------------*

  PRIVATE lOkyQ 
        dbo := connect2db("datetime.db3",nil) 
        lOkyQ := miscsql(dbo,'delete from datetime where NAME <> "" ')   

    if empty(dbo)
        return .f.
    else
       sqlite3_exec(dbo,"VACUUM")   // borra toda la Base de Datos
        hb_gcall( .t. )

    endif

RETURN

*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
*--------------------------------------------------------*
 Function Tablax()
*--------------------------------------------------------*

 Declare Window Win_1

   RESTORE FROM mirax.mem  ADDITIVE
   RESTORE FROM zAmundia.mem ADDITIVE
*-------------------------------------------------------------------------------------*
   IF BUSCAR = 'General Manager'         
      Win_1.bnuevo.Enabled         := HNIV1_8    
      Win_1.Bmodificar.Enabled     := HNIV2_8
      Win_1.beliminar.Enabled      := HNIV3_8    //  george       General Manager HNIV1_8 
      Win_1.bimprime.Enabled       := HNIV4_8 
      Win_1.PaswordX.Enabled       := HNIV5_8  
   ENDIF   
*-------------------------------------------------------------------------------------*
   IF BUSCAR = 'Manager R.Human'         
      Win_1.bnuevo.Enabled         := ANIV1_1 
      Win_1.Bmodificar.Enabled     := ANIV2_1 
      Win_1.beliminar.Enabled      := ANIV3_1    //  adam     Manager R.Human ANIV1_1 
      Win_1.bimprime.Enabled       := ANIV4_1 
      Win_1.PaswordX.Enabled       := ANIV5_1 
   ENDIF   
*-------------------------------------------------------------------------------------*  
  IF BUSCAR = 'Manager Financial'   
     Win_1.bnuevo.Enabled          := BNIV1_2 
     Win_1.Bmodificar.Enabled      := BNIV2_2 
     Win_1.beliminar.Enabled       := BNIV3_2   //   alfred  Manager Financial BNIV1_2         
     Win_1.bimprime.Enabled        := BNIV4_2 
     Win_1.PaswordX.Enabled        := BNIV5_2 
   ENDIF   
*-------------------------------------------------------------------------------------*   
   IF BUSCAR = 'Section Chief' 
      Win_1.bnuevo.Enabled         := ENIV1_5  
      Win_1.Bmodificar.Enabled     := ENIV2_5  
      Win_1.beliminar.Enabled      := ENIV3_5    //   betty     Section Chief ENIV1_5  
      Win_1.bimprime.Enabled       := ENIV4_5  
      Win_1.PaswordX.Enabled       := ENIV5_5  
   ENDIF   
*-------------------------------------------------------------------------------------*
   IF BUSCAR = 'Administrative Officer 1'    
      Win_1.bnuevo.Enabled         := FNIV1_6              
      Win_1.Bmodificar.Enabled     := FNIV2_6
      Win_1.beliminar.Enabled      := FNIV3_6  //   donna    Administrative Officer 1 FNIV1_6 
      Win_1.bimprime.Enabled       := FNIV4_6 
      Win_1.PaswordX.Enabled       := FNIV5_6     
   ENDIF   
*-------------------------------------------------------------------------------------*
   IF BUSCAR = 'Administrative Officer 2'  
      Win_1.bnuevo.Enabled         := CNIV1_3
      Win_1.Bmodificar.Enabled     := CNIV2_3     // alice   Administrative Officer 2 CNIV1_3
      Win_1.beliminar.Enabled      := CNIV3_3
      Win_1.bimprime.Enabled       := CNIV4_3 
      Win_1.PaswordX.Enabled       := CNIV5_3  
   ENDIF   
*-------------------------------------------------------------------------------------*   
   IF BUSCAR = 'Administrative Assistant'   
      Win_1.bnuevo.Enabled         :=  GNIV1_7   
      Win_1.Bmodificar.Enabled     :=  GNIV2_7 
      Win_1.beliminar.Enabled      :=  GNIV3_7   //  frank  Administrative Assistant GNIV1_7 
      Win_1.bimprime.Enabled       :=  GNIV4_7 
      Win_1.PaswordX.Enabled       :=  GNIV5_7 
   ENDIF 
*-------------------------------------------------------------------------------------* 
   IF BUSCAR = 'Broker'
      Win_1.bnuevo.Enabled         := DNIV1_4   
      Win_1.Bmodificar.Enabled     := DNIV2_4   
      Win_1.beliminar.Enabled      := DNIV3_4   // robert Boy Stock DNIV1_4   
      Win_1.bimprime.Enabled       := DNIV4_4   
      Win_1.PaswordX.Enabled       := DNIV5_4   
   ENDIF   
*-------------------------------------------------------------------------------------*  
   IF BUSCAR =  'Stock Foreman'  
      Win_1.bnuevo.Enabled         := INIV1_9     
      Win_1.Bmodificar.Enabled     := INIV2_9
      Win_1.beliminar.Enabled      := INIV3_9  // kend  Stock Foreman INIV1_9  
      Win_1.bimprime.Enabled       := INIV4_9 
      Win_1.PaswordX.Enabled       := INIV5_9  
   ENDIF   
*-------------------------------------------------------------------------------------*
   IF BUSCAR = 'Officer 1 Stock' 
      Win_1.bnuevo.Enabled         := JNIV1_10    
      Win_1.Bmodificar.Enabled     := JNIV2_10    
      Win_1.beliminar.Enabled      := JNIV3_10   //   mike  Officer 1 Stock JNIV1_10   
      Win_1.bimprime.Enabled       := JNIV4_10    
      Win_1.PaswordX.Enabled       := JNIV5_10    
   ENDIF    

*-------------------------------------------------------------------------------------*
   IF BUSCAR = 'Officer 2 Stock'  
      Win_1.bnuevo.Enabled         := LNIV1_12  
      Win_1.Bmodificar.Enabled     := LNIV2_12  
      Win_1.beliminar.Enabled      := LNIV3_12    // smith  Officer 2 Stock LNIV1_12   
      Win_1.bimprime.Enabled       := LNIV4_12  
      Win_1.PaswordX.Enabled       := LNIV5_12  
   ENDIF     
*-------------------------------------------------------------------------------------*
   IF BUSCAR = 'Boy Stock'  
      Win_1.bnuevo.Enabled         := KNIV1_11       
      Win_1.Bmodificar.Enabled     := KNIV2_11
      Win_1.beliminar.Enabled      := KNIV3_11     //  robert  Boy Stock KNIV1_11 
      Win_1.bimprime.Enabled       := KNIV4_11
      Win_1.PaswordX.Enabled       := KNIV5_11
   ENDIF   

 Return NIl

*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*









